#version 300 es

uniform sampler2D textureMap;

in mediump vec2 vTexCoord;

out lowp vec4 fragColor;

void main()
{
    highp vec2 texelSize = 1.0 / vec2( textureSize( textureMap, 0 ) );
	
    //	ideally use a fixed size noise and blur so that this loop can be unrolled
    fragColor = vec4( 0.0 );
    highp int uBlurSize = 4; // Should equal to noise texture size.
    highp vec2 hlim = vec2( float(-uBlurSize) * 0.5 + 0.5 );
    
    for (highp int x = 0; x < uBlurSize; ++x)
    {
        for (highp int y = 0; y < uBlurSize; ++y)
        {
            highp vec2 offset = vec2( float( x ), float( y ) );
            offset += hlim;
            offset *= texelSize;
            
            fragColor += texture( textureMap, vTexCoord + offset );
        }
	}
	
	fragColor = fragColor / float( uBlurSize * uBlurSize );
}

