#version 300 es

uniform sampler2D textureMap;
uniform sampler2D bloomMap;
uniform sampler2D ssaoMap;
uniform mediump float bloomFactor;

in mediump vec2 vTexCoord;

out lowp vec4 fragColor;

highp vec4 reinhard( in highp vec4 color )
{
    highp float exposure = 2.5;
    
    highp vec4 outColor = color;
    outColor *= exposure;
    outColor /= (1.0 + outColor);

    return outColor;
}

void main()
{
    mediump float exposure = 2.5;
    mediump float brightMax = 2.0;
    
    mediump vec4 color = texture( textureMap, vTexCoord );
    
    lowp vec4 ssao = texture( ssaoMap, vTexCoord );
    color *= ssao.r;
    
    mediump vec4 colorBloom = texture( bloomMap, vTexCoord );
    
    // Blooms only intense values.
    //mediump colorBloom = max( vec4( 0.0 ), colorBloom - 0.1 );
    
    // Add bloom to the image
    color += colorBloom * bloomFactor;
    
    fragColor = reinhard( color );
}

