#version 300 es

uniform highp mat4 _ViewProjectionMatrix;
uniform highp mat4 modelMatrix;
uniform highp mat4 boneMatrices[8];

layout (location = 0) in mediump vec4 aPosition;
layout (location = 1) in mediump vec2 aTexCoord;
layout (location = 4) in mediump vec4 aBoneIndex;
layout (location = 5) in mediump vec4 aBoneWeights;

out mediump vec2 vTexCoord;

void main()
{
    highp vec4 position = aPosition;
#ifdef SKIN
    ivec4 boneIndex = ivec4( aBoneIndex );

    position  = boneMatrices[ boneIndex.x ] * aPosition * aBoneWeights.x;
    position += boneMatrices[ boneIndex.y ] * aPosition * aBoneWeights.y;
    position += boneMatrices[ boneIndex.z ] * aPosition * aBoneWeights.z;
    position += boneMatrices[ boneIndex.w ] * aPosition * aBoneWeights.w;
#endif
    gl_Position = _ViewProjectionMatrix * modelMatrix * position;
    vTexCoord = aTexCoord;
}
