#version 150 core
#extension GL_ARB_explicit_attrib_location : enable

uniform mat4 _ViewProjectionMatrix;
uniform mat4 modelMatrix;
uniform vec4 textureMap_ST;
uniform vec3 morphWeights;

layout (location = 0) in vec4 aPosition; // Base mesh position.
layout (location = 1) in vec2 aTexCoord;
layout (location = 6) in vec4 aPosition1; // Morph target 1.
layout (location = 7) in vec4 aPosition2; // Morph target 2.

out vec2 vTexCoord;

void main()
{
    float weightSum = morphWeights.x + morphWeights.y;
    vec4 position = aPosition * (1.0 - weightSum);
    position += (aPosition1 * morphWeights.x);
    position += (aPosition2 * morphWeights.y);

    gl_Position = _ViewProjectionMatrix * modelMatrix * position;
    vTexCoord = aTexCoord * textureMap_ST.xy + textureMap_ST.zw;
}
