#version 150 core

uniform sampler2D textureMap;
uniform sampler2D bloomMap;
uniform sampler2D ssaoMap;
uniform float bloomFactor;

in vec2 vTexCoord;

out vec4 fragColor;

vec4 reinhard( in vec4 color )
{
    float exposure = 2.5;
    
    vec4 outColor = color;
    outColor *= exposure;
    outColor /= (1.0 + outColor);

    return outColor;
}

void main()
{
    vec4 color = texture( textureMap, vTexCoord, 0 );

    vec4 colorBloom = texture( bloomMap, vTexCoord );
    color += colorBloom * bloomFactor;

    fragColor = reinhard( color );

    // I read somewhere that SSAO should be applied after tonemap, don't remember the source.
    vec4 ssao = texture( ssaoMap, vTexCoord );
    fragColor *= ssao.a;
}

