#version 150 core
#extension GL_ARB_explicit_attrib_location : enable

uniform mat4 _ViewProjectionMatrix;
uniform mat4 modelMatrix;
uniform mat4 boneMatrices[8];
uniform vec4 textureMap_ST;

layout (location = 0) in vec4 aPosition;
layout (location = 1) in vec2 aTexCoord;
layout (location = 4) in vec4 aBoneIndex;
layout (location = 5) in vec4 aBoneWeights;

out vec2 vTexCoord;

void main()
{
    vec4 position = aPosition;
#ifdef SKIN
    ivec4 boneIndex = ivec4( aBoneIndex );

    position  = boneMatrices[ boneIndex.x ] * aPosition * aBoneWeights.x;
    position += boneMatrices[ boneIndex.y ] * aPosition * aBoneWeights.y;
    position += boneMatrices[ boneIndex.z ] * aPosition * aBoneWeights.z;
    position += boneMatrices[ boneIndex.w ] * aPosition * aBoneWeights.w;
#endif

    gl_Position = _ViewProjectionMatrix * modelMatrix * position;
    vTexCoord = aTexCoord * textureMap_ST.xy + textureMap_ST.zw;
}
