#ifndef MOUSE_INPUT_H
#define MOUSE_INPUT_H

namespace ae3d
{
namespace mouseinput
{
    enum Enum
    {
        MOUSE_BUTTON_LEFT = 0,
        MOUSE_BUTTON_RIGHT,
        MOUSE_BUTTON_MIDDLE
    };
}
}

/// Reads mouse
class MouseInput
{
  public:
    virtual ~MouseInput() {}
    /**
       \param outX If relative movement is false, cursor's X screen coordinate relative to upper-left corner is returned here.
       \param outY If relative movement is false, cursor's Y screen coordinate relative to upper-left corner is returned here.
     */
    virtual void GetPosition( int& outX, int& outY ) const;
    
    /**
       \param x X screen coordinate.
       \param y Y screen coordinate.
     */
    virtual void SetPosition( int x, int y ) const;
    
    /** \param enable Relative movement status. If true, GetPosition returns values relative to the prior state. Defaults to false. */
    virtual void SetRelative( bool enable ) const;

    /** \param enable True, if cursor will be shown, false otherwise. */
    virtual void ShowCursor( bool enable ) const;
    
    /**
       \param button Button.
       \return True, if button is down, false otherwise.
     */
    virtual bool IsDown( ae3d::mouseinput::Enum button ) const;
};
#endif
