#ifndef TEXTURE_H
#define TEXTURE_H

#include <string>

/// 2D or Cube Map texture.
class Texture
{
  public:
    /// Filter.
   enum class Filter { Point, Linear, Anisotropic8, Anisotropic16 };
    /// Tiling.
   enum class Tiling { Repeat, Clamp };

    /// Destructor.
    virtual ~Texture() {}

    /// \return Height in pixels.
    virtual int Height() const = 0;

    /// \return Width in pixels.
    virtual int Width() const = 0;
};
#endif
