#include "MouseInput.hpp"
#include "Platform.hpp"
#define VC_EXTRALEAN
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#ifdef AETHER3D_WINDOWS
#define AETHER3D_API __declspec(dllexport)
#else
#define AETHER3D_API 
#endif

extern "C" AETHER3D_API MouseInput* CreateMouseInput()
{
    return new MouseInput();
}

extern HWND hwnd;

bool gMouseButtonDown[ 3 ] = { false };
int gMousePosition[ 2 ] = { 0 };
bool gRelativeMouse = false;

void MouseInput::GetPosition( int& outX, int& outY ) const
{
    if (gRelativeMouse)
    {
        outX = gMousePosition[ 0 ] - Screen::Width() / 2;
        outY = gMousePosition[ 1 ] - Screen::Height() / 2;
        
        POINT center;
        center.x = Screen::Width() / 2;
        center.y = Screen::Height() / 2;
        ClientToScreen( hwnd, &center );
        SetCursorPos( center.x, center.y );

        return;
    }

    outX = gMousePosition[ 0 ];
    outY = gMousePosition[ 1 ];
}

void MouseInput::SetPosition( int x, int y ) const
{
    gMousePosition[ 0 ] = x;
    gMousePosition[ 1 ] = y;
    SetCursorPos( x, y );
}

void MouseInput::SetRelative( bool enable ) const
{
    gRelativeMouse = enable;

    /*if (enable)
    {
        SetCapture( hwnd );
    }
    else
    {
        ReleaseCapture();
    }*/
}

void MouseInput::ShowCursor( bool enable ) const
{
    static HCURSOR cursor = nullptr;

    if (!enable)
    {
        cursor = SetCursor( nullptr );
    }
    else
    {
        SetCursor( cursor );
    }
}

bool MouseInput::IsDown( ae3d::mouseinput::Enum button ) const
{
    return gMouseButtonDown[ button ];
}
