#ifndef COMPUTE_SHADER_H
#define COMPUTE_SHADER_H

#ifndef INCLUDE_MEMORY_H
#    include <memory>
#    define INCLUDE_MEMORY_H
#endif
#ifndef ERRORS_H
#    include "Errors.hpp"
#endif

class TextureImpl;
struct Matrix44;
struct Vec3;
struct Vec4;

class ComputeShader
{
public:
    ComputeShader();
    virtual ~ComputeShader();
    static void Deinit();
    void Dispatch( int numGroupsX, int numGroupsY, int numGroupsZ );
    void Load( const char* path, Error::Enum& outError );
#if AETHER3D_GL43
    void SetFloat( const char* name, float value );
    void SetInt( const char* name, int value );
    void SetUInt( const char* name, unsigned value );
    void SetVector( const char* name, const Vec3& value );
    void SetVector( const char* name, const Vec4& value );
    void SetMatrix( const char* name, const Matrix44& matrix );
#endif
    void Use();

private:
    struct Impl;
    std::unique_ptr< Impl > m;
};

#endif
