#include "Log.hpp"
#include <cassert>
#include <cstdarg>
#include <cstdio>

#ifdef _MSC_VER
#    define WIN32_LEAN_AND_MEAN
#    define VC_EXTRALEAN
#    include <Windows.h>
#endif

namespace Log
{
    void Print( const char* format, ... )
    {
        va_list ap;
        va_start( ap, format );

        char msg[ 512 ];
        vsnprintf( msg, sizeof(msg), format, ap );
        va_end( ap );
        std::printf( "%s\n", msg );
#ifdef _MSC_VER
        OutputDebugStringA( msg );
        OutputDebugStringA( "\n" );
#endif
        std::fflush( stdout );
    }

    void Assert( bool condition, const char* message )
    {
        if (!condition)
        {
            Print( "Assertion failed: %s", message );

#ifdef _MSC_VER
            __debugbreak();
#else
            // Linux: raise(SIGTRAP)
            assert( false );
#endif
        }
    }
}
