#include "Platform.hpp" 
#include <algorithm>
#include <chrono>
#include <string>

namespace Time
{
    double GetTime()
    {
        auto now = std::chrono::system_clock::now();
        auto duration = now.time_since_epoch();
        auto millis = std::chrono::duration_cast<std::chrono::milliseconds>(duration).count();
        return millis / 1000.0;
    }
}

std::string PathWithCorrectSeparators( const std::string& path )
{
#if AETHER3D_UNIX
    std::string pathStr( path );
    std::replace( std::begin( pathStr ), std::end( pathStr ), '\\', '/' );
    return pathStr;
#else
    return path;
#endif
}

#if !AETHER3D_IOS
const char* GetFullPath( const char* path )
{
    return path;
}
#endif
