#ifndef COMMON_H
#define COMMON_H
#include "Aether3D.hpp"
#include <iostream>

void HandleInput( const KeyboardInput* input, Camera* camera )
{
    const float speed = 0.3f;

    if (input->IsDown( ae3d::keyboardinput::KEY_a ))
    {
        camera->MoveRight( -speed );
    }
    if (input->IsDown( ae3d::keyboardinput::KEY_d ))
    {
        camera->MoveRight( speed );
    }
    if (input->IsDown( ae3d::keyboardinput::KEY_e ))
    {
        camera->MoveUp( speed );
    }
    if (input->IsDown( ae3d::keyboardinput::KEY_q ))
    {
        camera->MoveUp( -speed );
    }
    if (input->IsDown( ae3d::keyboardinput::KEY_w ))
    {
        camera->MoveForward( -speed );
    }
    if (input->IsDown( ae3d::keyboardinput::KEY_s ))
    {
        camera->MoveForward( speed );
    }
    if (input->IsDown( ae3d::keyboardinput::KEY_LEFT ))
    {
        camera->OffsetRotation( Vec3( 0, 1, 0 ), 1 );
    }
    if (input->IsDown( ae3d::keyboardinput::KEY_RIGHT ))
    {
        camera->OffsetRotation( Vec3( 0, 1, 0 ), -1 );
    }
    if (input->IsDown( ae3d::keyboardinput::KEY_UP ))
    {
        camera->OffsetRotation( Vec3( 1, 0, 0 ), 1 );
    }
    if (input->IsDown( ae3d::keyboardinput::KEY_DOWN ))
    {
        camera->OffsetRotation( Vec3( 1, 0, 0 ), -1 );
    }
}

// This code assumes that MouseInput's relative position is enabled.
void HandleInput( const MouseInput* mouseInput, Camera* camera )
{
    int x, y;
    mouseInput->GetPosition( x, y );

    camera->OffsetRotation( Vec3( 0, 1, 0 ), -float( x ) / 10 );
    camera->OffsetRotation( Vec3( 1, 0, 0 ), -float( y ) / 10 );
}

#endif
