#include <iostream>
#include <string>
#include "Aether3D.hpp"

int main( int paramCount, char* params[] )
{
    Aether3D_API dll;
    Error::Enum error = dll.LoadDLL( paramCount > 1 ? std::string( params[ 1 ] ) : "" );

    if (error != Error::NO_ERRORS)
    {
        return (int)error;
    }

    Renderer* renderer = dll.MakeRenderer( "../../Assets/builtin/" );

    if (!renderer)
    {
        return (int)Error::FACTORY_NOT_FOUND;
    }

    int width = 320;
    int height = 200;
    error = renderer->OpenWindow( width, height, false, 1, true );

    if (error != Error::NO_ERRORS)
    {
        return (int)error;
    }

    Material* material1 = dll.MakeMaterial();
    error = material1->SetShaders( "cook_torrance", "cook_torrance", "", "" );
    if (error != Error::NO_ERRORS)
    {
        std::cerr << "cook_torrance 1 failed!" << std::endl;
        return (int)error;
    }

    Material* material2 = dll.MakeMaterial();
    error = material2->SetShaders( "cook_torrance", "cook_torrance", "", "SPECULAR_MAP" );
    if (error != Error::NO_ERRORS)
    {
        std::cerr << "cook_torrance 2 failed!" << std::endl;
        return (int)error;
    }

    Material* material3 = dll.MakeMaterial();
    error = material3->SetShaders( "cook_torrance", "cook_torrance", "", "ENVIRONMENT_MAP" );
    if (error != Error::NO_ERRORS)
    {
        std::cerr << "cook_torrance 3 failed!" << std::endl;
        return (int)error;
    }

    Material* material4 = dll.MakeMaterial();
    error = material4->SetShaders( "cook_torrance", "cook_torrance", "", "SPECULAR_MAP ENVIRONMENT_MAP" );
    if (error != Error::NO_ERRORS)
    {
        std::cerr << "cook_torrance 4 failed!" << std::endl;
        return (int)error;
    }

    Material* material5 = dll.MakeMaterial();
    error = material5->SetShaders( "unlit", "unlit", "", "" );
    if (error != Error::NO_ERRORS)
    {
        std::cerr << "unlit failed!" << std::endl;
        return (int)error;
    }

    Material* material51 = dll.MakeMaterial();
    error = material51->SetShaders( "unlit", "unlit", "", "SKIN" );
    if (error != Error::NO_ERRORS)
    {
        std::cerr << "unlit failed!" << std::endl;
        return (int)error;
    }

    Material* material6 = dll.MakeMaterial();
    error = material6->SetShaders( "envmap", "envmap", "", "" );
    if (error != Error::NO_ERRORS)
    {
        std::cerr << "envmap failed!" << std::endl;
        return (int)error;
    }

    Material* material7 = dll.MakeMaterial();
    error = material7->SetShaders( "cubemap", "cubemap", "", "" );
    if (error != Error::NO_ERRORS)
    {
        std::cerr << "cubemap failed!" << std::endl;
        return (int)error;
    }

    return (int) error;
}

