#include <iostream>
#include <string>
#include "Aether3D.hpp"

int main( int paramCount, char* params[] )
{
    Aether3D_API dll;
    Error::Enum error = dll.LoadDLL( paramCount > 1 ? std::string( params[ 1 ] ) : "" );

    if (error != Error::NO_ERRORS)
    {
        return (int)error;
    }

    Renderer* renderer = dll.MakeRenderer( "../../Assets/builtin/" );

    if (!renderer)
    {
        return (int)Error::FACTORY_NOT_FOUND;
    }

    int width = 320;
    int height = 200;
    error = renderer->OpenWindow( width, height, false, 1, true );

    if (error != Error::NO_ERRORS)
    {
        return (int)error;
    }

    Scene* scene = dll.MakeScene();
    
    SceneGraphNode node;
    scene->RootNode().AddChild( &node );
    scene->Remove( &node );

    if (scene->RootNode().ContainsChild( &node ) )
    {
        std::cout << "Scene: Removing of node failed!" << std::endl;
        return Error::CONTRACT_VIOLATION;
    }
    
    return (int) error;
}

