#include "Log.hpp"
#include "MathUtil.hpp" 
#include "Frustum.hpp"
#include "Vec3.hpp"
#include <vector>

struct Box
{
    Vec3 min;
    Vec3 max;
};

int main()
{
    Frustum frustum;
    frustum.SetProjection( 55, 16.0f / 9.0f, 1, 200 );

    std::vector< Box > boxes( 2000 );

    for (auto& box : boxes)
    {
        box.min = Vec3( MathUtil::Random( -100, 100 ), MathUtil::Random( -100, 100 ), MathUtil::Random( 1, 200 ) );
        box.max = box.min + Vec3( 5, 5, 5 );
    }

    int in = 0;

    for (const auto& box : boxes)
    {
        in += frustum.BoxInFrustum( box.min, box.max ) ? 1 : 0;
    }

    Log::Print( "Boxes in frustum: %d", in );
}
